const setTimeout = require("timers/promises").setTimeout;
const rangi = require("rangi");

module.exports = async ({ jobId, tasks }) => {
  for (const task of tasks) {
    for (action of task) {
      if (!action.input && action.timeout) {
        console.log(
          rangi.green(
            `jobid ${jobId}: waiting ${action.duration}ms before carrying out next action`
          )
        );
        await setTimeout(action.duration);
      } else {
        console.log(
          rangi.cyan(
            `jobid ${jobId}: session: ${action.sessionId}, input: ${action.input}`
          )
        );
        await setTimeout(action.defaultWaitNextMenu);
      }
    }
  }

  return;
};
